function [FST_all,FST_allLoci,AC_allLoci] = calculateFST(Females_thisGen,FST_all,FST_k,u,num_msats,t,FST_allLoci,AC_allLoci)

Females = Females_thisGen(:,[2,5:end]);
size(unique(Females(:,2:end)),1)

% sample Females
Females = Females(randsample(1:size(Females,1),200),:); display('200 FEMALES are sampled to calculate FST')

uniq_alleles = unique(Females(:,2:end))';
allele_cnts = zeros(u,length(uniq_alleles),num_msats);
for region = 1:u
    for msat = 1:num_msats
        [Cnts,bins]=histcounts(Females(Females(:,1)==region,[msat+1,msat+1+num_msats]),[uniq_alleles,uniq_alleles(end)+1]);
        allele_cnts(region,:,msat)= Cnts;
    end
end

for msat = 1:num_msats
allele_cnts_marker = allele_cnts(:,:,msat);

AF = allele_cnts_marker./repmat(sum(allele_cnts_marker,2),1,length(uniq_alleles));
HS1 = nanmean(1-sum(AF.^2,2)); % mean across regions for one marker

AF_all = sum(allele_cnts(:,:,msat),1);

AF_all = AF_all./repmat(sum(AF_all,2),1,length(uniq_alleles));
HT = 1-sum(AF_all.^2,2);

FST1(msat) = 1-HS1./HT;
end
FST_allLoci(FST_k,:) = FST1;
FST1(FST1 < 0) = 0;

AC = reshape(sum(sum(allele_cnts>0,1)>0),1,num_msats);
AC_allLoci(FST_k,:) = AC;

FST_all(FST_k,1) = t;
FST_all(FST_k,2) = sum(AC>=3);
FST_all(FST_k,3) = mean(FST1(AC>=3));