function [F_all,M_all,DM_all,I_disp_f_all,I_disp_m_all,Females_thisGen,Males_thisGen,DipMales_thisGen] = wasp_migration(F_all,M_all,DM_all,C,u,Females_thisGen,Males_thisGen,DipMales_thisGen,t,h)

if u > 1 % if there are more than single sub-region
    Females_thisGen_old = Females_thisGen; % store the pre-migration populations
    Males_thisGen_old = Males_thisGen;
    DipMales_thisGen_old = DipMales_thisGen;
    F_all_newt = F_all(:,t); % vector that contains new population sizes after migration
    M_all_newt = M_all(:,t);
    DM_all_newt = DM_all(:,t);
    
    I_disp_f_all = []; % vector that contains the indicator for successful migrants (=1)
    I_disp_m_all = [];
    I_disp_dm_all = [];
    
    for region = 1:u
        D = find(C(:,region)>0);
        
        I_disp = rand(F_all(region,t)+M_all(region,t)+DM_all(region,t),1) < h;
        I_disp_f = I_disp(1:F_all(region,t));
        I_disp_m = I_disp(F_all(region,t)+1:F_all(region,t)+M_all(region,t));
        I_disp_dm = I_disp(F_all(region,t)+M_all(region,t)+1:F_all(region,t)+M_all(region,t)+DM_all(region,t));
        
        % Females
        where_this_pop = find(Females_thisGen_old(:,2)==region);
        
        if ~isempty(where_this_pop)
        DD = repmat(D',sum(I_disp_f),1);
            destin = sum(DD.*mnrnd(1,ones(1,sum(C(:,region)>0))/sum(C(:,region)>0),sum(I_disp_f)),2);
        Females_thisGen(where_this_pop(I_disp_f),2) = destin;
        
        I_disp_f_all = [I_disp_f_all;Females_thisGen(where_this_pop,2),I_disp_f];
        
        F_all_newt(region) = F_all_newt(region) - sum(I_disp_f);
        for dd = unique(destin)'
            F_all_newt(dd) = F_all_newt(dd) + sum(destin == dd);
        end
        
        end
        
        % Males
        where_this_pop = find(Males_thisGen_old(:,2)==region);
        
        if ~isempty(where_this_pop)
            
        DD = repmat(D',sum(I_disp_m),1);
        destin = sum(DD.*mnrnd(1,ones(1,sum(C(:,region)>0))/sum(C(:,region)>0),sum(I_disp_m)),2);
        
        Males_thisGen(where_this_pop(I_disp_m),2) = destin;
        
        I_disp_m_all = [I_disp_m_all;Males_thisGen(where_this_pop,2),I_disp_m];
        
        M_all_newt(region) = M_all_newt(region) - sum(I_disp_m);
        for dd = unique(destin)'
            M_all_newt(dd) = M_all_newt(dd) + sum(destin == dd);
        end
        
        end
        
        % DipMales
        where_this_pop = find(DipMales_thisGen_old(:,2)==region);
        
        if ~isempty(where_this_pop)
            
        DD = repmat(D',sum(I_disp_dm),1);
        destin = sum(DD.*mnrnd(1,ones(1,sum(C(:,region)>0))/sum(C(:,region)>0),sum(I_disp_dm)),2);
        
        DipMales_thisGen(where_this_pop(I_disp_dm),2) = destin;
        
        I_disp_dm_all = [I_disp_dm_all;DipMales_thisGen(where_this_pop,2),I_disp_dm];
        
        DM_all_newt(region) = DM_all_newt(region) - sum(I_disp_dm);
        for dd = unique(destin)'
            DM_all_newt(dd) = DM_all_newt(dd) + sum(destin == dd);
        end
        
        end
    end
    
    F_all(:,t) = F_all_newt; % replace the old populations with new populations
    M_all(:,t) = M_all_newt;
    DM_all(:,t) = DM_all_newt;
    
end
Females_thisGen_old = []; % empty the old generations
Males_thisGen_old = [];
DipMales_thisGen_old = [];